> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cloud.coinbase.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List Portfolio Wallets

> List all wallets associated with a given portfolio.

Use the Prime SDK or CLI to test this endpoint by following the [quickstart](/prime/introduction/quickstart) guide and running with the following examples

<Tabs>
  <Tab title="Java">
    ```java theme={null}
    WalletsService walletsService = PrimeServiceFactory.createWalletsService(client);

    ListWalletsRequest request = new ListWalletsRequest.Builder()
        .portfolioId("PORTFOLIO_ID_HERE")
        .type(WalletType.VAULT)
        .build();

    ListWalletsResponse response = walletsService.listWallets(request);
    ```

    For more information, please visit the [Prime Java SDK](https://github.com/coinbase-samples/prime-sdk-java).
  </Tab>

  <Tab title=".NET">
    ```csharp wrap theme={null}
    var walletsService = new WalletsService(client);

    var request = new ListWalletsRequest("PORTFOLIO_ID_HERE")
    {
        Type = WalletType.VAULT,
    }

    var response = walletsService.ListWallets(request);
    ```

    For more information, please visit the [Prime .NET SDK](https://github.com/coinbase-samples/prime-sdk-dotnet).
  </Tab>

  <Tab title="Go">
    ```go wrap theme={null}
    walletsService := users.NewWalletsService(client)

    request := &users.ListWalletsRequest{
        PortfolioId: "PORTFOLIO_ID_HERE",
        Type: "VAULT",
    }

    response, err := walletsService.ListWallets(context.Background(), request)
    ```

    For more information, please visit the [Prime Go SDK](https://github.com/coinbase-samples/prime-sdk-go).
  </Tab>

  <Tab title="Python">
    ```python wrap theme={null}
    prime_client = PrimeClient(credentials)

    request = ListWalletsRequest(
        portfolio_id="PORTFOLIO_ID_HERE",
        type="VAULT",
    )

    response = prime_client.list_wallets(request)
    ```

    For more information, please visit the [Prime Python SDK](https://github.com/coinbase-samples/prime-sdk-py).
  </Tab>

  <Tab title="CLI">
    ```bash wrap theme={null}
    primectl list-wallets --help
    ```

    For more information, please visit the [Prime CLI](https://github.com/coinbase-samples/prime-cli).
  </Tab>

  <Tab title="TS/JS">
    ```typescript wrap theme={null}
    const walletsService = new WalletsService(client);

    walletsService.listWallets({
        portfolioId: 'PORTFOLIO_ID_HERE',
        type: WalletType.VAULT,
    }).then(async (response) => {
        console.log('Wallets: ', response);
    })
    ```

    For more information, please visit the [Prime TS SDK](https://github.com/coinbase-samples/prime-sdk-ts).
  </Tab>
</Tabs>


## OpenAPI

````yaml GET /v1/portfolios/{portfolio_id}/wallets
openapi: 3.0.1
info:
  title: REST API
  description: >-
    The Coinbase Prime REST API provides programmatic access to trading,
    custody, staking, market data, and account management functionality.
  version: '0.1'
servers:
  - url: https://api.prime.coinbase.com/
security: []
tags:
  - name: PrimeRESTAPI
paths:
  /v1/portfolios/{portfolio_id}/wallets:
    get:
      tags:
        - Wallets
      summary: List Portfolio Wallets
      description: List all wallets associated with a given portfolio.
      operationId: PrimeRESTAPI_GetWallets
      parameters:
        - name: portfolio_id
          in: path
          description: The portfolio ID
          required: true
          schema:
            type: string
        - name: type
          in: query
          description: |-
            The wallet type

             - VAULT: A crypto vault
             - TRADING: A trading wallet
             - WALLET_TYPE_OTHER: Other wallet types (like consumer, etc)
             - QC: A QC Wallet
             - ONCHAIN: An Onchain wallet
          required: true
          schema:
            type: string
            enum:
              - VAULT
              - TRADING
              - WALLET_TYPE_OTHER
              - QC
              - ONCHAIN
        - name: cursor
          in: query
          description: Cursor used for pagination (last consumed record)
          schema:
            type: string
        - name: limit
          in: query
          description: Number of wallets to retrieve
          schema:
            type: integer
            format: int32
        - name: sort_direction
          in: query
          description: Sorting order
          schema:
            type: string
            default: DESC
            enum:
              - DESC
              - ASC
        - name: symbols
          in: query
          description: The wallet symbol
          style: form
          explode: true
          schema:
            type: array
            items:
              type: string
        - name: get_network_unified_wallets
          in: query
          description: >-
            Flag to request retrieval of all wallets across all networks for a
            given symbol
          schema:
            type: boolean
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/coinbase.public_rest_api.GetWalletsResponse
components:
  schemas:
    coinbase.public_rest_api.GetWalletsResponse:
      type: object
      properties:
        wallets:
          type: array
          items:
            $ref: '#/components/schemas/coinbase.public_rest_api.Wallet'
        pagination:
          $ref: '#/components/schemas/coinbase.public_rest_api.PaginatedResponse'
    coinbase.public_rest_api.Wallet:
      type: object
      properties:
        id:
          title: The unique UUID for the wallet
          type: string
        name:
          title: The name of the wallet
          type: string
        symbol:
          title: The asset stored in the wallet
          type: string
        type:
          $ref: '#/components/schemas/coinbase.public_rest_api.WalletType'
        created_at:
          title: The UTC timestamp when this wallet was created
          type: string
          format: date-time
        address:
          title: The active address of the wallet
          type: string
        visibility:
          $ref: '#/components/schemas/coinbase.public_rest_api.WalletVisibility'
        network:
          $ref: '#/components/schemas/coinbase.public_rest_api.Network'
    coinbase.public_rest_api.PaginatedResponse:
      required:
        - has_next
        - next_cursor
        - sort_direction
      type: object
      properties:
        next_cursor:
          type: string
          description: Cursor to navigate to next page
        sort_direction:
          $ref: '#/components/schemas/coinbase.public_rest_api.SortDirection'
        has_next:
          type: boolean
          description: >-
            A boolean value indicating whether there are more items to paginate
            through
    coinbase.public_rest_api.WalletType:
      title: Indicates the wallet type
      type: string
      description: |-
        - VAULT: A crypto vault
         - TRADING: A trading wallet
         - WALLET_TYPE_OTHER: Other wallet types (like consumer, etc)
         - QC: A QC Wallet
         - ONCHAIN: An Onchain wallet
      enum:
        - VAULT
        - TRADING
        - WALLET_TYPE_OTHER
        - QC
        - ONCHAIN
    coinbase.public_rest_api.WalletVisibility:
      type: string
      default: WALLET_VISIBILITY_UNSPECIFIED
      enum:
        - WALLET_VISIBILITY_UNSPECIFIED
        - WALLET_VISIBILITY_VISIBLE
        - WALLET_VISIBILITY_HIDDEN
    coinbase.public_rest_api.Network:
      type: object
      properties:
        id:
          title: The name of the network
          type: string
          description: 'The network id: base, bitcoin, ethereum, solana etc'
        type:
          title: The network type
          type: string
          description: 'The network type: mainnet, testnet, etc'
    coinbase.public_rest_api.SortDirection:
      type: string
      default: DESC
      enum:
        - DESC
        - ASC

````